#encoding=utf-8    
import wave  
import urllib, urllib2, pycurl  
import base64  
import json
import os
def get_token():  
    apiKey = "9qWKswM1zRdqnVxdUAStdCyb"  
    secretKey = "cb2db72b018aa8407c74f3b26a5bcd28"
    
    auth_url = "https://openapi.baidu.com/oauth/2.0/token?grant_type=client_credentials&client_id=" + apiKey + "&client_secret=" + secretKey;  
    res = urllib2.urlopen(auth_url)  
    json_data = res.read()  
    return json.loads(json_data)['access_token']  
def dump_res(buf):  
    print buf 
def use_cloud(token):
    os.system("sudo arecord -d 4 -D plughw:1,0 /home/pi/xiangmu/tulin/test.wav")
    fp = wave.open('/home/pi/xiangmu/tulin/test.wav', 'rb')
    nf = fp.getnframes()  
    f_len = nf * 2  
    audio_data = fp.readframes(nf)  
  
    cuid = "18409272907"
    srv_url = 'http://vop.baidu.com/server_api'+ '?cuid=' +cuid+ '&token='+ token  
    http_header = ['Content-Type: audio/wav; rate=8000','Content-Length: %d' % f_len]  #pcm
    c = pycurl.Curl()  
    c.setopt(pycurl.URL, str(srv_url))  
    #c.setopt(c.RETURNTRANSFER, 1)  
    c.setopt(c.HTTPHEADER, http_header)    
    c.setopt(c.POST, 1)  
    c.setopt(c.CONNECTTIMEOUT, 30)  
    c.setopt(c.TIMEOUT, 30)  
    c.setopt(c.WRITEFUNCTION, dump_res)  
    c.setopt(c.POSTFIELDS, audio_data)
    c.setopt(c.POSTFIELDSIZE, f_len)
    c.perform() 
if __name__ == "__main__":  
    token = get_token()  
    use_cloud(token)  
